/*
Complexitate timp : O(P^3)
30 puncte
*/
#include <stdio.h>
#define PMax 100005

FILE *fin = fopen("piscina.in", "rt");
FILE *fout = fopen("piscina.out", "wt");

int n, m;
int p, x[PMax], y[PMax];

// mirror xi relative to [0, n]
void mirror(int n, int *x) {
	for (int i = 0; i < p; i++) {
		x[i] = n-x[i];
	}
}

int max(int a, int b) {
	if (a > b) return a;
	return b;
}

int solve() {
	int amax = 0, area;

	for (int i = 0; i < p + 2; i++) {
		for (int j = i + 1; j < p + 2; j++) {

			// take points i and j as limits for the corner
			int xmax = max(x[i], x[j]);
			int ymax = max(y[i], y[j]);

			area = xmax;
			area *= ymax;
			if (area <= amax) {
				continue;
			}

			int good = 1;
			for (int k = 0; k < p && good; k++) {
				if (x[k] < xmax && y[k] < ymax) {
					good = 0;
				}
			}
			
			if (good) {
				amax = area;
			}
		}
	}
	return amax;
}

int main() {
	fscanf(fin, "%d %d %d", &n, &m, &p);
	for (int i = 0; i < p; i++) {
		fscanf(fin, "%d %d", &x[i], &y[i]);
	}
	x[p] = 0; y[p] = m;
	x[p+1] = n; y[p+1] = 0;

	int amax = 0;
	int area;

	area = solve(); if (amax < area) { amax = area; }
	mirror(n, x);
	area = solve(); if (amax < area) { amax = area; }
	mirror(m, y);
	area = solve(); if (amax < area) { amax = area; }
	mirror(n, x);
	area = solve(); if (amax < area) { amax = area; }

	fprintf(fout, "%ld\n", amax);
	fclose(fin);
	fclose(fout);
	return 0;
}